if Fence:HasModule('Clicks') then return end

local L = AceLibrary("AceLocale-2.2"):new("Fence_Clicks")
local l = AceLibrary("AceLocale-2.2"):new("Fence")

-- Localization
L:RegisterTranslations("enUS", function() 
	return {
		["Clicks"] = true,
		["fill"] = true,
		["search"] = true,		
		["split"] = true,
		["trade"] = true		
	}
end)

L:RegisterTranslations("deDE", function()
	return {
		["Clicks"] = "Clicks",
		["fill"] = "Ausf\195\188llen",
		["search"] = "Suchen",
		["split"] = "Teilen",
		["trade"] = "Trade"
	}
end)

Fence_Clicks = Fence:NewModule("Clicks")


	function Fence_Clicks:OnInitialize()
		self.db = Fence:AcquireDBNamespace("Clicks")
		if self.db.profile.Fill == nil then self.db.profile.Fill = true end
		if self.db.profile.Search == nil then self.db.profile.Search = true end
		if self.db.profile.Split == nil then self.db.profile.Split = true end
		if self.db.profile.Trade == nil then self.db.profile.Trade = true end
		
		Fence.options.args.clicks = {
			type = 'group',
			name = L["Clicks"],
			desc = string.format(l["%s options"], L["Clicks"]),
				args = {
					toggle = {
						type = 'toggle',
						name = L["Clicks"],
						desc = string.format(l["Toggles %s function."], L["Clicks"]),
						get = function() return Fence:IsModuleActive("Clicks") end,
						set = function(v) Fence:ToggleModuleActive("Clicks", v) end
					},
					fill = {
						type = 'toggle',
						name = L["fill"],
						desc = string.format(l["Toggles %s function."], L["fill"]),
						get = function() return self.db.profile.Fill end,
						set = function(v) self.db.profile.Fill = v end
					},
					search = {
						type = 'toggle',
						name = L["search"],
						desc = string.format(l["Toggles %s function."], L["search"]),
						get = function() return self.db.profile.Search end,
						set = function(v) self.db.profile.Search = v end
					},
					split = {
						type = 'toggle',
						name = L["split"],
						desc = string.format(l["Toggles %s function."], L["split"]),
						get = function() return self.db.profile.Split end,
						set = function(v) self.db.profile.Split = v end
					},
					trade = {
						type = 'toggle',
						name = L["trade"],
						desc = string.format(l["Toggles %s function."], L["trade"]),
						get = function() return self.db.profile.Trade end,
						set = function(v) self.db.profile.Trade = v end
					},
				}
		}
	end

	function Fence_Clicks:OnEnable()
		self:SecureHook("ContainerFrameItemButton_OnModifiedClick")
	end
	
	function Fence_Clicks:OnDisable()
		if self:IsHooked("ContainerFrameItemButton_OnModifiedClick") then self:Unhook("ContainerFrameItemButton_OnModifiedClick") end
	end

	
	function Fence_Clicks:ContainerFrameItemButton_OnModifiedClick(...)
		local bag, item = this:GetParent():GetID(), this:GetID()
		if AuctionFrame and AuctionFrame:IsVisible() and not CursorHasItem() then
			if (...) == "LeftButton" and IsAltKeyDown() and GetContainerItemLink(bag, item) then
				PickupContainerItem(bag, item)
				ClickAuctionSellItemButton()
				StartAuction(MoneyInputFrame_GetCopper(StartPrice), MoneyInputFrame_GetCopper(BuyoutPrice), AuctionFrameAuctions.duration)
				if not AuctionFrameAuctions:IsVisible() then AuctionFrameTab3:Click() end
					return
			elseif (...) == "RightButton" then 
				if IsControlKeyDown() and self.db.profile.Search then self:AuctionSearch(GetContainerItemLink(bag, item))	end
				if IsAltKeyDown() and self.db.profile.Split then self:Splitter(bag, item, 1) end
				if IsShiftKeyDown() and self.db.profile.Split then self:Splitter(bag, item) end
                    return
			end
		elseif TradeFrame:IsVisible() and (...) == "LeftButton" and IsAltKeyDown() and self.db.profile.Trade and not CursorHasItem() then
			PickupContainerItem(bag, item)
			local slot = TradeFrame_GetAvailableSlot()
			if slot then ClickTradeButton(slot) end
				return
		elseif (...) == "RightButton" then 
            if IsAltKeyDown() and self.db.profile.Split then self:Splitter(bag, item, 1) end
			if IsShiftKeyDown() and self.db.profile.Split then self:Splitter(bag, item) end
                return
		end
	end
	
	function Fence_Clicks:Splitter(bag, item, amount)
        if not amount then 
            local _, count =  GetContainerItemInfo(bag, item)
            amount = floor(count/2)
        end
		SplitContainerItem(bag, item, amount)
		for Bag=0,4 do
			for slot=1, GetContainerNumSlots(Bag) do
				if not GetContainerItemLink(Bag, slot) then	PickupContainerItem(Bag, slot) return end
			end
		end
	end

	function Fence_Clicks:AuctionSearch(link)
		if link and not strfind(link,"item:") then return end
		BrowseMinLevel:SetText('')
		BrowseMaxLevel:SetText('')
		UIDropDownMenu_SetText('',BrowseDropDown)
		UIDropDownMenu_SetSelectedName(BrowseDropDown)
		local i,j,name = strfind(link,"%[(.+)%]")
		BrowseName:SetText(name)
		BrowseName:HighlightText(0,-1)
		IsUsableCheckButton:SetChecked(false)
		AuctionFrameBrowse.selectedSubclassIndex = nil
		AuctionFrameBrowse.selectedInvtype = nil
		AuctionFrameBrowse.selectedInvtypeIndex = nil
		AuctionFrameFilters_Update()
		BrowseSearchButton:Click()
		if not AuctionFrameBrowse:IsVisible() then AuctionFrameTab1:Click() end
	end
